function [cxd, czd] = DICTdetector(CX, CZ, N, QF, bpb, mode, z, NR, ND)

dictname = ['0'];
if (QF==2.5),
    if (mode==1), 
        if (ND==32), dictname = ['dict25_32.mat']; end
        if (ND==64), dictname = ['dict25_64.mat']; end
        if (ND==128), dictname = ['dict25_128.mat']; end
    end
else
    return;
end

load(dictname);

r = size(CX,1);
c = size(CX,2);
wmr = floor(r/N);
wmc = floor(c/N);

cxd = zeros(wmr*N, wmc*N);
czd = zeros(wmr*N, wmc*N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end

for rr = 1:wmr,
    for cc = 1:wmc,
        tempcb = CX((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        meanv = mean2(tempcb);
        tempcb = tempcb - meanv;
        tempcb = tempcb / sqrt(sum2(tempcb.*tempcb));
        tempcb = tempcb(:);
        w0 = sparseapprox(tempcb, Dcx0, 'OMP', 'tnz',NR);
        w2 = sparseapprox(tempcb, Dcx1, 'OMP', 'tnz',NR);
        w4 = sparseapprox(tempcb, Dcx2, 'OMP', 'tnz',NR);
        w6 = sparseapprox(tempcb, Dcx3, 'OMP', 'tnz',NR);
        sc0 = sum((tempcb-Dcx0*w0).^2);
        sc2 = sum((tempcb-Dcx1*w2).^2);
        sc4 = sum((tempcb-Dcx2*w4).^2);
        sc6 = sum((tempcb-Dcx3*w6).^2);
        if ((sc0 < sc2)&&(sc0 < sc4)&&(sc0 < sc6)),
            cxd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 0;
        elseif ((sc2 < sc0)&&(sc2 < sc4)&&(sc2 < sc6)),
            cxd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 70;
        elseif ((sc4 < sc0)&&(sc4 < sc2)&&(sc4 < sc6)),
            cxd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 140;
        else cxd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 210;
        end
        
        tempcb = CZ((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        meanv = mean2(tempcb);
        tempcb = tempcb - meanv;
        tempcb = tempcb / sqrt(sum2(tempcb.*tempcb));
        tempcb = tempcb(:);
        w0 = sparseapprox(tempcb, Dcz0, 'OMP', 'tnz',NR);
        w2 = sparseapprox(tempcb, Dcz1, 'OMP', 'tnz',NR);
        w4 = sparseapprox(tempcb, Dcz2, 'OMP', 'tnz',NR);
        w6 = sparseapprox(tempcb, Dcz3, 'OMP', 'tnz',NR);
        sc0 = sum((tempcb-Dcz0*w0).^2);
        sc2 = sum((tempcb-Dcz1*w2).^2);
        sc4 = sum((tempcb-Dcz2*w4).^2);
        sc6 = sum((tempcb-Dcz3*w6).^2);
        if ((sc0 < sc2)&&(sc0 < sc4)&&(sc0 < sc6)),
            czd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 0;
        elseif ((sc2 < sc0)&&(sc2 < sc4)&&(sc2 < sc6)),
            czd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 70;
        elseif ((sc4 < sc0)&&(sc4 < sc2)&&(sc4 < sc6)),
            czd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 140;
        else czd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 210;
        end
    end
end



