function [cxd, czd] = MOMdetector(Cx, Cz, N, QF, bpb, mode)  

featpdfs = ['0'];
if (QF==2.5),
    if (mode==1), 
        featpdfs = ['mompdfs25.mat'];
    end
else
    return;
end

load(featpdfs);

r = size(Cx,1);
c = size(Cx,2);
wmr = floor(r/N);
wmc = floor(c/N);

cxd = zeros(wmr*N, wmc*N);
czd = zeros(wmr*N, wmc*N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end

mask2 = ones(Nf,Nf);
mask2(floor(Nf/2)+1:floor(Nf/2)+1,floor(Nf/2)+1:floor(Nf/2)+1) = 0;

scorescx1 = zeros(1,wmr*wmc);
scorescx2 = zeros(1,wmr*wmc);
scorescx3 = zeros(1,wmr*wmc);
scorescx4 = zeros(1,wmr*wmc);
scorescz1 = zeros(1,wmr*wmc);
scorescz2 = zeros(1,wmr*wmc);
scorescz3 = zeros(1,wmr*wmc);
scorescz4 = zeros(1,wmr*wmc);
scoresall = zeros(8,wmr*wmc);
countscores = 0;
b = 80:60/100:140;

for rr = 1:wmr,
    for cc = 1:wmc,
%%%%%% Cx detection:        
        tempcb = Cx((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        meanv = (sum2(tempcb(:,:)) - sum2(tempcb(floor(Nf/2)+1:floor(Nf/2)+1,floor(Nf/2)+1:floor(Nf/2)+1))) / (Nf*Nf-1);
        tempcb = tempcb - meanv;
        tempcb = tempcb.*mask2;
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));

        countscores = countscores + 1;
        moms = findmoments(tempcb);
        scorescx1(countscores) = moms(1);
        scorescx2(countscores) = moms(2);
        scorescx3(countscores) = moms(3);
        scorescx4(countscores) = moms(4);
        scoresall(1:4,countscores)=[moms(1),moms(2),moms(3),moms(4)]';

        tempcb = Cz((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        meanv = (sum2(tempcb(:,:)) - sum2(tempcb(floor(Nf/2)+1:floor(Nf/2)+1,floor(Nf/2)+1:floor(Nf/2)+1))) / (Nf*Nf-1);
        tempcb = tempcb - meanv;
        tempcb = tempcb.*mask2;
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));
        
        moms = findmoments(tempcb);
        scorescz1(countscores) = moms(1);
        scorescz2(countscores) = moms(2);
        scorescz3(countscores) = moms(3);
        scorescz4(countscores) = moms(4);
        scoresall(5:8,countscores)=[moms(1),moms(2),moms(3),moms(4)]';
        
        maxscore = 0; bCx = 0; bCz = 0;
        for tcx = 1:4,
            for tcz = 1:4,
                tmpscore = 1;
                
                for fe = 1:8,
                    tmppdf = mompdfs{tcx,tcz,fe};
                    pdfscore = interp1(b,tmppdf,scoresall(fe,countscores),'linear');
                    tmpscore = tmpscore*pdfscore;             
                end
 
                if (tmpscore>maxscore),
                    maxscore = tmpscore;
                    bCx = (tcx-1)*70;
                    bCz = (tcz-1)*70;
                end
               
            end
        end
        cxd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = bCx;
        czd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = bCz;         
        
    end
end


