function [cxd, czd] = PCAdetector(Cx, Cz, N, QF, bpb, mode, NC)   

feats = ['0'];
featpdfs = ['0'];
if (QF==2.5),
    if (mode==1), 
        feats = ['fpca25.mat'];
        featpdfs = ['pcapdfs25.mat'];
    end
else
    return;
end

CompInd = [];
    
load(feats);
load(featpdfs);  

if (NC==2),
    CompInd = [1,2,3,4];
else
    return;
end


fcx1 = fcx1/sqrt(sum2(fcx1.*fcx1));
fcx2 = fcx2/sqrt(sum2(fcx2.*fcx2));
fcz1 = fcz1/sqrt(sum2(fcz1.*fcz1));
fcz2 = fcz2/sqrt(sum2(fcz2.*fcz2));

r = size(Cx,1);
c = size(Cx,2);
wmr = floor(r/N);
wmc = floor(c/N);

cxd = zeros(wmr*N, wmc*N);
czd = zeros(wmr*N, wmc*N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end


scorescx1 = zeros(1,wmr*wmc);
scorescx2 = zeros(1,wmr*wmc);
scorescz1 = zeros(1,wmr*wmc);
scorescz2 = zeros(1,wmr*wmc);
scoresall = zeros(6,wmr*wmc);
countscores = 0;
b = -1:1/50:1;

for rr = 1:wmr,
    for cc = 1:wmc,
        tempcb = Cx((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        tempcb = tempcb - mean2(tempcb);
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));

        countscores = countscores + 1;
        score1 = sum2(tempcb.*fcx1);
        score2 = sum2(tempcb.*fcx2);
        scorescx1(countscores) = score1;
        scorescx2(countscores) = score2;
        scoresall(1:2,countscores) = [score1,score2]';

        tempcb = Cz((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        tempcb = tempcb - mean2(tempcb);
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));
        
        score1 = sum2(tempcb.*fcz1);
        score2 = sum2(tempcb.*fcz2);
        scorescz1(countscores) = score1;
        scorescz2(countscores) = score2;        
        scoresall(3:4,countscores) = [score1,score2]';

        maxscore = 0; bCx = 0; bCz = 0;
        for tcx = 1:4,
            for tcz = 1:4,
                tmpscore = 1;
                
                for fe = CompInd,
                    tmppdf = pcapdfs{tcx,tcz,fe};
                    pdfscore = interp1(b,tmppdf,scoresall(fe,countscores),'linear');
                    tmpscore = tmpscore*pdfscore;             
                end
 
                if (tmpscore>maxscore),
                    maxscore = tmpscore;
                    bCx = (tcx-1)*70;
                    bCz = (tcz-1)*70;
                end
               
            end
        end
        cxd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = bCx;
        czd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = bCz;

    end
end



