function [crd, cbd] = detectPCAold(Cx, Cz, N, QF, bpb, mode)

if mod(QF*10,10)==5, QF = QF * 10; end

wm0 = ['WM0_',num2str(N),'_',num2str(QF),mode,'.mat'];
wm2 = ['WM2_',num2str(N),'_',num2str(QF),mode,'.mat'];
wm4 = ['WM4_',num2str(N),'_',num2str(QF),mode,'.mat'];
wm6 = ['WM6_',num2str(N),'_',num2str(QF),mode,'.mat'];

load(wm0);
load(wm2);
load(wm4);
load(wm6);

r = size(Cx,1);
c = size(Cx,2);
wmr = floor(r/N);
wmc = floor(c/N);

cbd = zeros(wmr*N, wmc*N);
crd = zeros(wmr*N, wmc*N);

S1 = 0; S2 = 0;
if N==32, Nf = 21; S1 = 7; S2 = 5; end

mask2 = ones(N,N);
mask2(N/2:N/2+2,N/2:N/2+2) = 0;

y01cx = y01cx.*mask2(S1:N-S2,S1:N-S2);y02cx = y02cx.*mask2(S1:N-S2,S1:N-S2);y03cx = y03cx.*mask2(S1:N-S2,S1:N-S2);
y21cx = y21cx.*mask2(S1:N-S2,S1:N-S2);y22cx = y22cx.*mask2(S1:N-S2,S1:N-S2);y23cx = y23cx.*mask2(S1:N-S2,S1:N-S2);
y41cx = y41cx.*mask2(S1:N-S2,S1:N-S2);y42cx = y42cx.*mask2(S1:N-S2,S1:N-S2);y43cx = y43cx.*mask2(S1:N-S2,S1:N-S2);
y61cx = y61cx.*mask2(S1:N-S2,S1:N-S2);y62cx = y62cx.*mask2(S1:N-S2,S1:N-S2);y63cx = y63cx.*mask2(S1:N-S2,S1:N-S2);

y01cz = y01cz.*mask2(S1:N-S2,S1:N-S2);y02cz = y02cz.*mask2(S1:N-S2,S1:N-S2);y03cz = y03cz.*mask2(S1:N-S2,S1:N-S2);
y21cz = y21cz.*mask2(S1:N-S2,S1:N-S2);y22cz = y22cz.*mask2(S1:N-S2,S1:N-S2);y23cz = y23cz.*mask2(S1:N-S2,S1:N-S2);
y41cz = y41cz.*mask2(S1:N-S2,S1:N-S2);y42cz = y42cz.*mask2(S1:N-S2,S1:N-S2);y43cz = y43cz.*mask2(S1:N-S2,S1:N-S2);
y61cz = y61cz.*mask2(S1:N-S2,S1:N-S2);y62cz = y62cz.*mask2(S1:N-S2,S1:N-S2);y63cz = y63cz.*mask2(S1:N-S2,S1:N-S2);

f = -1;
f2 = 1;

for rr = 1:wmr,
    for cc = 1:wmc,
%%%%%% Cz detection:        
        tempcb = Cz((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N);
        tempcb = tempcb.*mask2;
        tempcb = tempcb - (sum2(tempcb) / (Nf*Nf-9));
        tempcb = tempcb.*mask2;
        
        score01 = sum2(tempcb(S1:N-S2,S1:N-S2).*y01cz);
        score21 = sum2(tempcb(S1:N-S2,S1:N-S2).*y21cz);
        score41 = sum2(tempcb(S1:N-S2,S1:N-S2).*y41cz);
        score61 = sum2(tempcb(S1:N-S2,S1:N-S2).*y61cz);
        
        score02 = sum2(tempcb(S1:N-S2,S1:N-S2).*y02cz);
        score22 = sum2(tempcb(S1:N-S2,S1:N-S2).*y22cz);
        score42 = sum2(tempcb(S1:N-S2,S1:N-S2).*y42cz);
        score62 = sum2(tempcb(S1:N-S2,S1:N-S2).*y62cz);
        
        zc = max([score01, score21, score41, score61]);
        if (zc<0),
            score0 = score01; score2 = score21; score4 = score41; score6 = score61; 
        else            
            score0 = (score01+f*score02)-f2*(score41+f*score42);
            score2 = (score21+f*score22)-f2*(score61+f*score62);
            score4 = (score41+f*score42)-f2*(score01+f*score02);
            score6 = (score61+f*score62)-f2*(score21+f*score22);
        end
        
        sv = sort([score0, score2, score4, score6],'descend'); 
        maxv = sv(1);
        if (score0==maxv), cbd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 0; end
        if (score2==maxv), cbd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 70; end
        if (score4==maxv), cbd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 140; end
        if (score6==maxv), cbd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 210; end
        
%%%%%% Cx detection:
        
        tempcr = Cx((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N);
        tempcr = tempcr.*mask2;
        tempcr = tempcr - (sum2(tempcr) / (Nf*Nf-9));
        tempcr = tempcr.*mask2;
        
        score01 = sum2(tempcr(S1:N-S2,S1:N-S2).*y01cx);
        score21 = sum2(tempcr(S1:N-S2,S1:N-S2).*y21cx);
        score41 = sum2(tempcr(S1:N-S2,S1:N-S2).*y41cx);
        score61 = sum2(tempcr(S1:N-S2,S1:N-S2).*y61cx);
        
        score02 = sum2(tempcr(S1:N-S2,S1:N-S2).*y02cx);
        score22 = sum2(tempcr(S1:N-S2,S1:N-S2).*y22cx);
        score42 = sum2(tempcr(S1:N-S2,S1:N-S2).*y42cx);
        score62 = sum2(tempcr(S1:N-S2,S1:N-S2).*y62cx);

        zc = max([score01, score21, score41, score61]);
        if (zc<0),
            score0 = score01; score2 = score21; score4 = score41;score6 = score61;
        else            
            score0 = (score01+f*score02)-f2*(score41+f*score42);
            score2 = (score21+f*score22)-f2*(score61+f*score62);
            score4 = (score41+f*score42)-f2*(score01+f*score02);
            score6 = (score61+f*score62)-f2*(score21+f*score22);
        end
        sv = sort([score0, score2, score4, score6],'descend'); 
        maxv = sv(1);
        if (score0==maxv), crd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 0; end
        if (score2==maxv), crd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 70; end
        if (score4==maxv), crd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 140; end
        if (score6==maxv), crd((rr-1)*N+1:rr*N,(cc-1)*N+1:cc*N) = 210; end
        
    end
end

cbd = uint8(cbd);
crd = uint8(crd);
