function dict = trainDICTs(CC, N, z, ND)

r = size(CC,1);
c = size(CC,2);
wmr = floor(r/N);
wmc = floor(c/N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end

X = zeros(1024,wmr*wmc);
count = 0;
for rr = 1:wmr,
    for cc = 1:wmc,
        count = count + 1;

        tempcb = CC((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        meanv = mean2(tempcb);
        tempcb = tempcb - meanv;
        tempcb = tempcb / sqrt(sum2(tempcb.*tempcb));
        
        tempcb = tempcb(:);
        X(:,count) = tempcb;       
    end
end

[Nd,L] = size(X); 
D0 = dictnormalize(X(:,3000+(1:ND))); nofIt = 10;

dlsMOD = struct('D',D0, 'Met','K-SVD', 'vsMet','OMP', 'vsArg',struct('tnz',4));
dlsMOD.snr = zeros(1,nofIt);
tic; for i=1:nofIt; dlsMOD = dlfun(dlsMOD, X, 1); end; toc;
dict = dlsMOD.D;