function [scorescx1, scorescx2, scorescx3, scorescx4, scorescz1, scorescz2, scorescz3, scorescz4] = trainlmspdf(Cx, Cz, N, QF, bpb, mode, z)   

feats = ['0'];
featpdfs = ['0'];
if (QF==2.5),
    if (mode==1),
        feats = ['flms25.mat'];
        featpdfs = ['lmspdfs25.mat'];
    end
else
    return;
end

load(feats);

r = size(Cx,1);
c = size(Cx,2);
wmr = floor(r/N);
wmc = floor(c/N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end

scorescx1 = zeros(1,wmr*wmc);
scorescx2 = zeros(1,wmr*wmc);
scorescx3 = zeros(1,wmr*wmc);
scorescx4 = zeros(1,wmr*wmc);
scorescz1 = zeros(1,wmr*wmc);
scorescz2 = zeros(1,wmr*wmc);
scorescz3 = zeros(1,wmr*wmc);
scorescz4 = zeros(1,wmr*wmc);
scoresall = zeros(8,wmr*wmc);
countscores = 0;

for rr = 1:wmr,
    for cc = 1:wmc,
        tempcb = Cx((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);       
        meanv = mean2(tempcb);
        tempcb = tempcb - meanv;
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));
        countscores = countscores + 1;
        score1 = sum2(tempcb.*fcx1);
        score2 = sum2(tempcb.*fcx2);
        score3 = sum2(tempcb.*fcx3);
        score4 = sum2(tempcb.*fcx4);
        scorescx1(countscores) = score1;
        scorescx2(countscores) = score2;
        scorescx3(countscores) = score3;
        scorescx4(countscores) = score4;
        scoresall(1:4,countscores)=[score1,score2,score3,score4]';

        tempcb = Cz((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        meanv = mean2(tempcb);
        tempcb = tempcb - meanv;
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));       
        score1 = sum2(tempcb.*fcz1);
        score2 = sum2(tempcb.*fcz2);
        score3 = sum2(tempcb.*fcz3);
        score4 = sum2(tempcb.*fcz4);
        scorescz1(countscores) = score1;
        scorescz2(countscores) = score2;
        scorescz3(countscores) = score3;
        scorescz4(countscores) = score4;
        scoresall(5:8,countscores)=[score1,score2,score3,score4]';              
    end
end



