function [scorescx1, scorescx2, scorescz1, scorescz2] = trainpcapdf(Cx, Cz, N, QF, bpb, mode)   

feats = ['0'];
featpdfs = ['0'];
if (QF==2.5),
    if (mode==1), 
        feats = ['fpca25.mat'];
        featpdfs = ['pcapdfs25.mat'];
    end
else
    return;
end
   
load(feats);

fcx1 = fcx1/sqrt(sum2(fcx1.*fcx1));
fcx2 = fcx2/sqrt(sum2(fcx2.*fcx2));
fcz1 = fcz1/sqrt(sum2(fcz1.*fcz1));
fcz2 = fcz2/sqrt(sum2(fcz2.*fcz2));

r = size(Cx,1);
c = size(Cx,2);
wmr = floor(r/N);
wmc = floor(c/N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end

scorescx1 = zeros(1,wmr*wmc);
scorescx2 = zeros(1,wmr*wmc);
scorescz1 = zeros(1,wmr*wmc);
scorescz2 = zeros(1,wmr*wmc);
scoresall = zeros(6,wmr*wmc);
countscores = 0;

for rr = 1:wmr,
    for cc = 1:wmc,
        tempcb = Cx((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        tempcb = tempcb - mean2(tempcb);
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));
        countscores = countscores + 1;
        score1 = sum2(tempcb.*fcx1);
        score2 = sum2(tempcb.*fcx2);
        scorescx1(countscores) = score1;
        scorescx2(countscores) = score2;
        scoresall(1:2,countscores) = [score1,score2]';

        tempcb = Cz((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);
        tempcb = tempcb - mean2(tempcb);
        tempcb = tempcb/sqrt(sum2(tempcb.*tempcb));       
        score1 = sum2(tempcb.*fcz1);
        score2 = sum2(tempcb.*fcz2);
        scorescz1(countscores) = score1;
        scorescz2(countscores) = score2;
        scoresall(3:4,countscores) = [score1,score2]';
    end
end



